/*
 * q_srv02_enc.c
 *
 * Real-Time Workshop code generation for Simulink model "q_srv02_enc.mdl".
 *
 * Model version              : 1.193
 * Real-Time Workshop version : 7.5  (R2010a)  25-Jan-2010
 * C source code generated on : Mon Dec 05 12:11:21 2011
 *
 * Target selection: quarc_windows.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: 32-bit Generic
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "q_srv02_enc.h"
#include "q_srv02_enc_private.h"
#include <stdio.h>
#include "q_srv02_enc_dt.h"

/* Block signals (auto storage) */
BlockIO_q_srv02_enc q_srv02_enc_B;

/* Block states (auto storage) */
D_Work_q_srv02_enc q_srv02_enc_DWork;

/* Real-time model */
RT_MODEL_q_srv02_enc q_srv02_enc_M_;
RT_MODEL_q_srv02_enc *q_srv02_enc_M = &q_srv02_enc_M_;

/* Model output function */
void q_srv02_enc_output(int_T tid)
{
  real_T temp;

  /* S-Function (hil_read_analog_timebase_block): '<Root>/HIL Read Analog Timebase' */

  /* S-Function Block: q_srv02_enc/HIL Read Analog Timebase (hil_read_analog_timebase_block) */
  {
    t_error result;
    result = hil_task_read_analog(q_srv02_enc_DWork.HILReadAnalogTimebase_Task,
      1, &q_srv02_enc_DWork.HILReadAnalogTimebase_Buffer[0]);
    if (result < 0) {
      msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
        (_rt_error_message));
      rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
    }

    q_srv02_enc_B.HILReadAnalogTimebase_o1 =
      q_srv02_enc_DWork.HILReadAnalogTimebase_Buffer[0];
    q_srv02_enc_B.HILReadAnalogTimebase_o2 =
      q_srv02_enc_DWork.HILReadAnalogTimebase_Buffer[1];
  }

  /* S-Function (hil_read_encoder_block): '<Root>/HIL Read Encoder' */

  /* S-Function Block: q_srv02_enc/HIL Read Encoder (hil_read_encoder_block) */
  {
    t_error result = hil_read_encoder(q_srv02_enc_DWork.HILInitialize_Card,
      &q_srv02_enc_P.HILReadEncoder_Channels, 1,
      &q_srv02_enc_DWork.HILReadEncoder_Buffer);
    if (result < 0) {
      msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
        (_rt_error_message));
      rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
    } else {
      q_srv02_enc_B.HILReadEncoder = q_srv02_enc_DWork.HILReadEncoder_Buffer;
    }
  }

  /* Gain: '<Root>/Encoder Calibration  (deg//count)' */
  q_srv02_enc_B.EncoderCalibrationdegcount =
    q_srv02_enc_P.EncoderCalibrationdegcount_Gain * q_srv02_enc_B.HILReadEncoder;

  /* Gain: '<Root>/Potentiometer Calibration (deg//V)' */
  q_srv02_enc_B.PotentiometerCalibrationdegV =
    q_srv02_enc_P.PotentiometerCalibrationdegV_Ga *
    q_srv02_enc_B.HILReadAnalogTimebase_o1;

  /* Gain: '<Root>/Tachometer Calibration (krpm//V)' */
  q_srv02_enc_B.TachometerCalibrationkrpmV =
    q_srv02_enc_P.TachometerCalibrationkrpmV_Gain *
    q_srv02_enc_B.HILReadAnalogTimebase_o2;

  /* SignalGenerator: '<Root>/Signal Generator' */
  temp = 6.2831853071795862E+000 * q_srv02_enc_M->Timing.t[0];
  q_srv02_enc_B.SignalGenerator = sin(q_srv02_enc_P.SignalGenerator_Frequency *
    temp) * q_srv02_enc_P.SignalGenerator_Amplitude;

  /* Gain: '<S1>/Slider Gain' */
  q_srv02_enc_B.SliderGain = q_srv02_enc_P.SliderGain_Gain *
    q_srv02_enc_B.SignalGenerator;

  /* Gain: '<Root>/Motor Calibration  (V//V)' */
  q_srv02_enc_B.MotorCalibrationVV = q_srv02_enc_P.MotorCalibrationVV_Gain *
    q_srv02_enc_B.SliderGain;

  /* S-Function (hil_write_block): '<Root>/HIL Write' */

  /* S-Function Block: q_srv02_enc/HIL Write (hil_write_block) */
  {
    t_error result;
    result = hil_write(q_srv02_enc_DWork.HILInitialize_Card,
                       &q_srv02_enc_P.HILWrite_AnalogChannels, 1U,
                       NULL, 0U,
                       NULL, 0U,
                       NULL, 0U,
                       &q_srv02_enc_B.MotorCalibrationVV,
                       NULL,
                       NULL,
                       NULL
                       );
    if (result < 0) {
      msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
        (_rt_error_message));
      rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
    }
  }

  /* tid is required for a uniform function interface.
   * Argument tid is not used in the function. */
  UNUSED_PARAMETER(tid);
}

/* Model update function */
void q_srv02_enc_update(int_T tid)
{
  /* Update absolute time for base rate */
  /* The "clockTick0" counts the number of times the code of this task has
   * been executed. The absolute time is the multiplication of "clockTick0"
   * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
   * overflow during the application lifespan selected.
   * Timer of this task consists of two 32 bit unsigned integers.
   * The two integers represent the low bits Timing.clockTick0 and the high bits
   * Timing.clockTickH0. When the low bit overflows to 0, the high bits increment.
   */
  if (!(++q_srv02_enc_M->Timing.clockTick0)) {
    ++q_srv02_enc_M->Timing.clockTickH0;
  }

  q_srv02_enc_M->Timing.t[0] = q_srv02_enc_M->Timing.clockTick0 *
    q_srv02_enc_M->Timing.stepSize0 + q_srv02_enc_M->Timing.clockTickH0 *
    q_srv02_enc_M->Timing.stepSize0 * 4294967296.0;

  {
    /* Update absolute timer for sample time: [0.002s, 0.0s] */
    /* The "clockTick1" counts the number of times the code of this task has
     * been executed. The absolute time is the multiplication of "clockTick1"
     * and "Timing.stepSize1". Size of "clockTick1" ensures timer will not
     * overflow during the application lifespan selected.
     * Timer of this task consists of two 32 bit unsigned integers.
     * The two integers represent the low bits Timing.clockTick1 and the high bits
     * Timing.clockTickH1. When the low bit overflows to 0, the high bits increment.
     */
    if (!(++q_srv02_enc_M->Timing.clockTick1)) {
      ++q_srv02_enc_M->Timing.clockTickH1;
    }

    q_srv02_enc_M->Timing.t[1] = q_srv02_enc_M->Timing.clockTick1 *
      q_srv02_enc_M->Timing.stepSize1 + q_srv02_enc_M->Timing.clockTickH1 *
      q_srv02_enc_M->Timing.stepSize1 * 4294967296.0;
  }

  /* tid is required for a uniform function interface.
   * Argument tid is not used in the function. */
  UNUSED_PARAMETER(tid);
}

/* Model initialize function */
void q_srv02_enc_initialize(boolean_T firstTime)
{
  (void)firstTime;

  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* initialize real-time model */
  (void) memset((void *)q_srv02_enc_M, 0,
                sizeof(RT_MODEL_q_srv02_enc));

  {
    /* Setup solver object */
    rtsiSetSimTimeStepPtr(&q_srv02_enc_M->solverInfo,
                          &q_srv02_enc_M->Timing.simTimeStep);
    rtsiSetTPtr(&q_srv02_enc_M->solverInfo, &rtmGetTPtr(q_srv02_enc_M));
    rtsiSetStepSizePtr(&q_srv02_enc_M->solverInfo,
                       &q_srv02_enc_M->Timing.stepSize0);
    rtsiSetErrorStatusPtr(&q_srv02_enc_M->solverInfo, (&rtmGetErrorStatus
      (q_srv02_enc_M)));
    rtsiSetRTModelPtr(&q_srv02_enc_M->solverInfo, q_srv02_enc_M);
  }

  rtsiSetSimTimeStep(&q_srv02_enc_M->solverInfo, MAJOR_TIME_STEP);
  rtsiSetSolverName(&q_srv02_enc_M->solverInfo,"FixedStepDiscrete");

  /* Initialize timing info */
  {
    int_T *mdlTsMap = q_srv02_enc_M->Timing.sampleTimeTaskIDArray;
    mdlTsMap[0] = 0;
    mdlTsMap[1] = 1;
    q_srv02_enc_M->Timing.sampleTimeTaskIDPtr = (&mdlTsMap[0]);
    q_srv02_enc_M->Timing.sampleTimes = (&q_srv02_enc_M->
      Timing.sampleTimesArray[0]);
    q_srv02_enc_M->Timing.offsetTimes = (&q_srv02_enc_M->
      Timing.offsetTimesArray[0]);

    /* task periods */
    q_srv02_enc_M->Timing.sampleTimes[0] = (0.0);
    q_srv02_enc_M->Timing.sampleTimes[1] = (0.002);

    /* task offsets */
    q_srv02_enc_M->Timing.offsetTimes[0] = (0.0);
    q_srv02_enc_M->Timing.offsetTimes[1] = (0.0);
  }

  rtmSetTPtr(q_srv02_enc_M, &q_srv02_enc_M->Timing.tArray[0]);

  {
    int_T *mdlSampleHits = q_srv02_enc_M->Timing.sampleHitArray;
    mdlSampleHits[0] = 1;
    mdlSampleHits[1] = 1;
    q_srv02_enc_M->Timing.sampleHits = (&mdlSampleHits[0]);
  }

  rtmSetTFinal(q_srv02_enc_M, -1);
  q_srv02_enc_M->Timing.stepSize0 = 0.002;
  q_srv02_enc_M->Timing.stepSize1 = 0.002;

  /* external mode info */
  q_srv02_enc_M->Sizes.checksums[0] = (3302166870U);
  q_srv02_enc_M->Sizes.checksums[1] = (1616928413U);
  q_srv02_enc_M->Sizes.checksums[2] = (1395123599U);
  q_srv02_enc_M->Sizes.checksums[3] = (1147411383U);

  {
    static const sysRanDType rtAlwaysEnabled = SUBSYS_RAN_BC_ENABLE;
    static RTWExtModeInfo rt_ExtModeInfo;
    static const sysRanDType *systemRan[1];
    q_srv02_enc_M->extModeInfo = (&rt_ExtModeInfo);
    rteiSetSubSystemActiveVectorAddresses(&rt_ExtModeInfo, systemRan);
    systemRan[0] = &rtAlwaysEnabled;
    rteiSetModelMappingInfoPtr(q_srv02_enc_M->extModeInfo,
      &q_srv02_enc_M->SpecialInfo.mappingInfo);
    rteiSetChecksumsPtr(q_srv02_enc_M->extModeInfo,
                        q_srv02_enc_M->Sizes.checksums);
    rteiSetTPtr(q_srv02_enc_M->extModeInfo, rtmGetTPtr(q_srv02_enc_M));
  }

  q_srv02_enc_M->solverInfoPtr = (&q_srv02_enc_M->solverInfo);
  q_srv02_enc_M->Timing.stepSize = (0.002);
  rtsiSetFixedStepSize(&q_srv02_enc_M->solverInfo, 0.002);
  rtsiSetSolverMode(&q_srv02_enc_M->solverInfo, SOLVER_MODE_SINGLETASKING);

  /* block I/O */
  q_srv02_enc_M->ModelData.blockIO = ((void *) &q_srv02_enc_B);

  {
    q_srv02_enc_B.HILReadAnalogTimebase_o1 = 0.0;
    q_srv02_enc_B.HILReadAnalogTimebase_o2 = 0.0;
    q_srv02_enc_B.HILReadEncoder = 0.0;
    q_srv02_enc_B.EncoderCalibrationdegcount = 0.0;
    q_srv02_enc_B.PotentiometerCalibrationdegV = 0.0;
    q_srv02_enc_B.TachometerCalibrationkrpmV = 0.0;
    q_srv02_enc_B.SignalGenerator = 0.0;
    q_srv02_enc_B.SliderGain = 0.0;
    q_srv02_enc_B.MotorCalibrationVV = 0.0;
  }

  /* parameters */
  q_srv02_enc_M->ModelData.defaultParam = ((real_T *)&q_srv02_enc_P);

  /* states (dwork) */
  q_srv02_enc_M->Work.dwork = ((void *) &q_srv02_enc_DWork);
  (void) memset((void *)&q_srv02_enc_DWork, 0,
                sizeof(D_Work_q_srv02_enc));

  {
    int_T i;
    for (i = 0; i < 8; i++) {
      q_srv02_enc_DWork.HILInitialize_AIMinimums[i] = 0.0;
    }
  }

  {
    int_T i;
    for (i = 0; i < 8; i++) {
      q_srv02_enc_DWork.HILInitialize_AIMaximums[i] = 0.0;
    }
  }

  {
    int_T i;
    for (i = 0; i < 8; i++) {
      q_srv02_enc_DWork.HILInitialize_AOMinimums[i] = 0.0;
    }
  }

  {
    int_T i;
    for (i = 0; i < 8; i++) {
      q_srv02_enc_DWork.HILInitialize_AOMaximums[i] = 0.0;
    }
  }

  {
    int_T i;
    for (i = 0; i < 8; i++) {
      q_srv02_enc_DWork.HILInitialize_AOVoltages[i] = 0.0;
    }
  }

  {
    int_T i;
    for (i = 0; i < 8; i++) {
      q_srv02_enc_DWork.HILInitialize_FilterFrequency[i] = 0.0;
    }
  }

  {
    int_T i;
    for (i = 0; i < 8; i++) {
      q_srv02_enc_DWork.HILInitialize_POSortedFreqs[i] = 0.0;
    }
  }

  {
    int_T i;
    for (i = 0; i < 8; i++) {
      q_srv02_enc_DWork.HILInitialize_POValues[i] = 0.0;
    }
  }

  q_srv02_enc_DWork.HILReadAnalogTimebase_Buffer[0] = 0.0;
  q_srv02_enc_DWork.HILReadAnalogTimebase_Buffer[1] = 0.0;

  /* data type transition information */
  {
    static DataTypeTransInfo dtInfo;
    (void) memset((char_T *) &dtInfo, 0,
                  sizeof(dtInfo));
    q_srv02_enc_M->SpecialInfo.mappingInfo = (&dtInfo);
    dtInfo.numDataTypes = 16;
    dtInfo.dataTypeSizes = &rtDataTypeSizes[0];
    dtInfo.dataTypeNames = &rtDataTypeNames[0];

    /* Block I/O transition table */
    dtInfo.B = &rtBTransTable;

    /* Parameters transition table */
    dtInfo.P = &rtPTransTable;
  }
}

/* Model terminate function */
void q_srv02_enc_terminate(void)
{
  /* Terminate for S-Function (hil_initialize_block): '<Root>/HIL Initialize' */

  /* S-Function Block: q_srv02_enc/HIL Initialize (hil_initialize_block) */
  {
    t_boolean is_switching;
    t_int result;
    hil_task_stop_all(q_srv02_enc_DWork.HILInitialize_Card);
    hil_task_delete_all(q_srv02_enc_DWork.HILInitialize_Card);
    hil_monitor_stop_all(q_srv02_enc_DWork.HILInitialize_Card);
    hil_monitor_delete_all(q_srv02_enc_DWork.HILInitialize_Card);
    is_switching = reconfiguration_is_switching_out(_reconfiguration);
    if ((q_srv02_enc_P.HILInitialize_AOTerminate && !is_switching) ||
        (q_srv02_enc_P.HILInitialize_AOExit && is_switching)) {
      {
        int_T i1;
        real_T *dw_AOVoltages = &q_srv02_enc_DWork.HILInitialize_AOVoltages[0];
        for (i1=0; i1 < 8; i1++) {
          dw_AOVoltages[i1] = q_srv02_enc_P.HILInitialize_AOFinal;
        }
      }

      result = hil_write_analog(q_srv02_enc_DWork.HILInitialize_Card,
        &q_srv02_enc_P.HILInitialize_AOChannels[0], 8U,
        &q_srv02_enc_DWork.HILInitialize_AOVoltages[0]);
      if (result < 0) {
        msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
          (_rt_error_message));
        rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
      }
    }

    if ((q_srv02_enc_P.HILInitialize_POTerminate && !is_switching) ||
        (q_srv02_enc_P.HILInitialize_POExit && is_switching)) {
      {
        int_T i1;
        real_T *dw_POValues = &q_srv02_enc_DWork.HILInitialize_POValues[0];
        for (i1=0; i1 < 8; i1++) {
          dw_POValues[i1] = q_srv02_enc_P.HILInitialize_POFinal;
        }
      }

      result = hil_write_pwm(q_srv02_enc_DWork.HILInitialize_Card,
        &q_srv02_enc_P.HILInitialize_POChannels[0], 8U,
        &q_srv02_enc_DWork.HILInitialize_POValues[0]);
      if (result < 0) {
        msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
          (_rt_error_message));
        rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
      }
    }

    hil_close(q_srv02_enc_DWork.HILInitialize_Card);
    q_srv02_enc_DWork.HILInitialize_Card = NULL;
  }
}

/*========================================================================*
 * Start of GRT compatible call interface                                 *
 *========================================================================*/
void MdlOutputs(int_T tid)
{
  q_srv02_enc_output(tid);
}

void MdlUpdate(int_T tid)
{
  q_srv02_enc_update(tid);
}

void MdlInitializeSizes(void)
{
  q_srv02_enc_M->Sizes.numContStates = (0);/* Number of continuous states */
  q_srv02_enc_M->Sizes.numY = (0);     /* Number of model outputs */
  q_srv02_enc_M->Sizes.numU = (0);     /* Number of model inputs */
  q_srv02_enc_M->Sizes.sysDirFeedThru = (0);/* The model is not direct feedthrough */
  q_srv02_enc_M->Sizes.numSampTimes = (2);/* Number of sample times */
  q_srv02_enc_M->Sizes.numBlocks = (14);/* Number of blocks */
  q_srv02_enc_M->Sizes.numBlockIO = (9);/* Number of block outputs */
  q_srv02_enc_M->Sizes.numBlockPrms = (108);/* Sum of parameter "widths" */
}

void MdlInitializeSampleTimes(void)
{
}

void MdlInitialize(void)
{
}

void MdlStart(void)
{
  /* Start for S-Function (hil_initialize_block): '<Root>/HIL Initialize' */

  /* S-Function Block: q_srv02_enc/HIL Initialize (hil_initialize_block) */
  {
    t_int result;
    t_boolean is_switching;
    result = hil_open("q8_usb", "0", &q_srv02_enc_DWork.HILInitialize_Card);
    if (result < 0) {
      msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
        (_rt_error_message));
      rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
      return;
    }

    is_switching = reconfiguration_is_switching_in(_reconfiguration);
    result = hil_set_card_specific_options(q_srv02_enc_DWork.HILInitialize_Card,
      "update_rate=normal", 19);
    if (result < 0) {
      msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
        (_rt_error_message));
      rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
      return;
    }

    result = hil_watchdog_clear(q_srv02_enc_DWork.HILInitialize_Card);
    if (result < 0 && result != -QERR_HIL_WATCHDOG_CLEAR) {
      msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
        (_rt_error_message));
      rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
      return;
    }

    if ((q_srv02_enc_P.HILInitialize_AIPStart && !is_switching) ||
        (q_srv02_enc_P.HILInitialize_AIPEnter && is_switching)) {
      {
        int_T i1;
        real_T *dw_AIMinimums = &q_srv02_enc_DWork.HILInitialize_AIMinimums[0];
        for (i1=0; i1 < 8; i1++) {
          dw_AIMinimums[i1] = q_srv02_enc_P.HILInitialize_AILow;
        }
      }

      {
        int_T i1;
        real_T *dw_AIMaximums = &q_srv02_enc_DWork.HILInitialize_AIMaximums[0];
        for (i1=0; i1 < 8; i1++) {
          dw_AIMaximums[i1] = q_srv02_enc_P.HILInitialize_AIHigh;
        }
      }

      result = hil_set_analog_input_ranges(q_srv02_enc_DWork.HILInitialize_Card,
        &q_srv02_enc_P.HILInitialize_AIChannels[0], 8U,
        &q_srv02_enc_DWork.HILInitialize_AIMinimums[0],
        &q_srv02_enc_DWork.HILInitialize_AIMaximums[0]);
      if (result < 0) {
        msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
          (_rt_error_message));
        rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
        return;
      }
    }

    if ((q_srv02_enc_P.HILInitialize_AOPStart && !is_switching) ||
        (q_srv02_enc_P.HILInitialize_AOPEnter && is_switching)) {
      {
        int_T i1;
        real_T *dw_AOMinimums = &q_srv02_enc_DWork.HILInitialize_AOMinimums[0];
        for (i1=0; i1 < 8; i1++) {
          dw_AOMinimums[i1] = q_srv02_enc_P.HILInitialize_AOLow;
        }
      }

      {
        int_T i1;
        real_T *dw_AOMaximums = &q_srv02_enc_DWork.HILInitialize_AOMaximums[0];
        for (i1=0; i1 < 8; i1++) {
          dw_AOMaximums[i1] = q_srv02_enc_P.HILInitialize_AOHigh;
        }
      }

      result = hil_set_analog_output_ranges(q_srv02_enc_DWork.HILInitialize_Card,
        &q_srv02_enc_P.HILInitialize_AOChannels[0], 8U,
        &q_srv02_enc_DWork.HILInitialize_AOMinimums[0],
        &q_srv02_enc_DWork.HILInitialize_AOMaximums[0]);
      if (result < 0) {
        msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
          (_rt_error_message));
        rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
        return;
      }
    }

    if ((q_srv02_enc_P.HILInitialize_AOStart && !is_switching) ||
        (q_srv02_enc_P.HILInitialize_AOEnter && is_switching)) {
      {
        int_T i1;
        real_T *dw_AOVoltages = &q_srv02_enc_DWork.HILInitialize_AOVoltages[0];
        for (i1=0; i1 < 8; i1++) {
          dw_AOVoltages[i1] = q_srv02_enc_P.HILInitialize_AOInitial;
        }
      }

      result = hil_write_analog(q_srv02_enc_DWork.HILInitialize_Card,
        &q_srv02_enc_P.HILInitialize_AOChannels[0], 8U,
        &q_srv02_enc_DWork.HILInitialize_AOVoltages[0]);
      if (result < 0) {
        msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
          (_rt_error_message));
        rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
        return;
      }
    }

    if (q_srv02_enc_P.HILInitialize_AOReset) {
      {
        int_T i1;
        real_T *dw_AOVoltages = &q_srv02_enc_DWork.HILInitialize_AOVoltages[0];
        for (i1=0; i1 < 8; i1++) {
          dw_AOVoltages[i1] = q_srv02_enc_P.HILInitialize_AOWatchdog;
        }
      }

      result = hil_watchdog_set_analog_expiration_state
        (q_srv02_enc_DWork.HILInitialize_Card,
         &q_srv02_enc_P.HILInitialize_AOChannels[0], 8U,
         &q_srv02_enc_DWork.HILInitialize_AOVoltages[0]);
      if (result < 0) {
        msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
          (_rt_error_message));
        rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
        return;
      }
    }

    if ((q_srv02_enc_P.HILInitialize_EIPStart && !is_switching) ||
        (q_srv02_enc_P.HILInitialize_EIPEnter && is_switching)) {
      {
        int_T i1;
        int32_T *dw_QuadratureModes =
          &q_srv02_enc_DWork.HILInitialize_QuadratureModes[0];
        for (i1=0; i1 < 8; i1++) {
          dw_QuadratureModes[i1] = q_srv02_enc_P.HILInitialize_EIQuadrature;
        }
      }

      result = hil_set_encoder_quadrature_mode
        (q_srv02_enc_DWork.HILInitialize_Card,
         &q_srv02_enc_P.HILInitialize_EIChannels[0], 8U,
         (t_encoder_quadrature_mode *)
         &q_srv02_enc_DWork.HILInitialize_QuadratureModes[0]);
      if (result < 0) {
        msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
          (_rt_error_message));
        rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
        return;
      }
    }

    if ((q_srv02_enc_P.HILInitialize_EIStart && !is_switching) ||
        (q_srv02_enc_P.HILInitialize_EIEnter && is_switching)) {
      {
        int_T i1;
        int32_T *dw_InitialEICounts =
          &q_srv02_enc_DWork.HILInitialize_InitialEICounts[0];
        for (i1=0; i1 < 8; i1++) {
          dw_InitialEICounts[i1] = q_srv02_enc_P.HILInitialize_EIInitial;
        }
      }

      result = hil_set_encoder_counts(q_srv02_enc_DWork.HILInitialize_Card,
        &q_srv02_enc_P.HILInitialize_EIChannels[0], 8U,
        &q_srv02_enc_DWork.HILInitialize_InitialEICounts[0]);
      if (result < 0) {
        msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
          (_rt_error_message));
        rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
        return;
      }
    }

    if ((q_srv02_enc_P.HILInitialize_POPStart && !is_switching) ||
        (q_srv02_enc_P.HILInitialize_POPEnter && is_switching)) {
      uint32_T num_duty_cycle_modes = 0;
      uint32_T num_frequency_modes = 0;

      {
        int_T i1;
        int32_T *dw_POModeValues =
          &q_srv02_enc_DWork.HILInitialize_POModeValues[0];
        for (i1=0; i1 < 8; i1++) {
          dw_POModeValues[i1] = q_srv02_enc_P.HILInitialize_POModes;
        }
      }

      result = hil_set_pwm_mode(q_srv02_enc_DWork.HILInitialize_Card,
        &q_srv02_enc_P.HILInitialize_POChannels[0], 8U, (t_pwm_mode *)
        &q_srv02_enc_DWork.HILInitialize_POModeValues[0]);
      if (result < 0) {
        msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
          (_rt_error_message));
        rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
        return;
      }

      {
        int_T i1;
        const uint32_T *p_HILInitialize_POChannels =
          &q_srv02_enc_P.HILInitialize_POChannels[0];
        int32_T *dw_POModeValues =
          &q_srv02_enc_DWork.HILInitialize_POModeValues[0];
        for (i1=0; i1 < 8; i1++) {
          if (dw_POModeValues[i1] == PWM_DUTY_CYCLE_MODE || dw_POModeValues[i1] ==
              PWM_ONE_SHOT_MODE || dw_POModeValues[i1] == PWM_TIME_MODE) {
            q_srv02_enc_DWork.HILInitialize_POSortedChans[num_duty_cycle_modes] =
              (p_HILInitialize_POChannels[i1]);
            q_srv02_enc_DWork.HILInitialize_POSortedFreqs[num_duty_cycle_modes] =
              q_srv02_enc_P.HILInitialize_POFrequency;
            num_duty_cycle_modes++;
          } else {
            q_srv02_enc_DWork.HILInitialize_POSortedChans[7U -
              num_frequency_modes] = (p_HILInitialize_POChannels[i1]);
            q_srv02_enc_DWork.HILInitialize_POSortedFreqs[7U -
              num_frequency_modes] = q_srv02_enc_P.HILInitialize_POFrequency;
            num_frequency_modes++;
          }
        }
      }

      if (num_duty_cycle_modes > 0) {
        result = hil_set_pwm_frequency(q_srv02_enc_DWork.HILInitialize_Card,
          &q_srv02_enc_DWork.HILInitialize_POSortedChans[0],
          num_duty_cycle_modes, &q_srv02_enc_DWork.HILInitialize_POSortedFreqs[0]);
        if (result < 0) {
          msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
            (_rt_error_message));
          rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
          return;
        }
      }

      if (num_frequency_modes > 0) {
        result = hil_set_pwm_duty_cycle(q_srv02_enc_DWork.HILInitialize_Card,
          &q_srv02_enc_DWork.HILInitialize_POSortedChans[num_duty_cycle_modes],
          num_frequency_modes,
          &q_srv02_enc_DWork.HILInitialize_POSortedFreqs[num_duty_cycle_modes]);
        if (result < 0) {
          msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
            (_rt_error_message));
          rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
          return;
        }
      }

      {
        int_T i1;
        int32_T *dw_POModeValues =
          &q_srv02_enc_DWork.HILInitialize_POModeValues[0];
        for (i1=0; i1 < 8; i1++) {
          dw_POModeValues[i1] = q_srv02_enc_P.HILInitialize_POConfiguration;
        }
      }

      {
        int_T i1;
        int32_T *dw_POAlignValues =
          &q_srv02_enc_DWork.HILInitialize_POAlignValues[0];
        for (i1=0; i1 < 8; i1++) {
          dw_POAlignValues[i1] = q_srv02_enc_P.HILInitialize_POAlignment;
        }
      }

      {
        int_T i1;
        int32_T *dw_POPolarityVals =
          &q_srv02_enc_DWork.HILInitialize_POPolarityVals[0];
        for (i1=0; i1 < 8; i1++) {
          dw_POPolarityVals[i1] = q_srv02_enc_P.HILInitialize_POPolarity;
        }
      }

      result = hil_set_pwm_configuration(q_srv02_enc_DWork.HILInitialize_Card,
        &q_srv02_enc_P.HILInitialize_POChannels[0], 8U,
        (t_pwm_configuration *) &q_srv02_enc_DWork.HILInitialize_POModeValues[0],
        (t_pwm_alignment *) &q_srv02_enc_DWork.HILInitialize_POAlignValues[0],
        (t_pwm_polarity *) &q_srv02_enc_DWork.HILInitialize_POPolarityVals[0]);
      if (result < 0) {
        msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
          (_rt_error_message));
        rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
        return;
      }

      {
        int_T i1;
        real_T *dw_POSortedFreqs =
          &q_srv02_enc_DWork.HILInitialize_POSortedFreqs[0];
        for (i1=0; i1 < 8; i1++) {
          dw_POSortedFreqs[i1] = q_srv02_enc_P.HILInitialize_POLeading;
        }
      }

      {
        int_T i1;
        real_T *dw_POValues = &q_srv02_enc_DWork.HILInitialize_POValues[0];
        for (i1=0; i1 < 8; i1++) {
          dw_POValues[i1] = q_srv02_enc_P.HILInitialize_POTrailing;
        }
      }

      result = hil_set_pwm_deadband(q_srv02_enc_DWork.HILInitialize_Card,
        &q_srv02_enc_P.HILInitialize_POChannels[0], 8U,
        &q_srv02_enc_DWork.HILInitialize_POSortedFreqs[0],
        &q_srv02_enc_DWork.HILInitialize_POValues[0]);
      if (result < 0) {
        msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
          (_rt_error_message));
        rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
        return;
      }
    }

    if ((q_srv02_enc_P.HILInitialize_POStart && !is_switching) ||
        (q_srv02_enc_P.HILInitialize_POEnter && is_switching)) {
      {
        int_T i1;
        real_T *dw_POValues = &q_srv02_enc_DWork.HILInitialize_POValues[0];
        for (i1=0; i1 < 8; i1++) {
          dw_POValues[i1] = q_srv02_enc_P.HILInitialize_POInitial;
        }
      }

      result = hil_write_pwm(q_srv02_enc_DWork.HILInitialize_Card,
        &q_srv02_enc_P.HILInitialize_POChannels[0], 8U,
        &q_srv02_enc_DWork.HILInitialize_POValues[0]);
      if (result < 0) {
        msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
          (_rt_error_message));
        rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
        return;
      }
    }

    if (q_srv02_enc_P.HILInitialize_POReset) {
      {
        int_T i1;
        real_T *dw_POValues = &q_srv02_enc_DWork.HILInitialize_POValues[0];
        for (i1=0; i1 < 8; i1++) {
          dw_POValues[i1] = q_srv02_enc_P.HILInitialize_POWatchdog;
        }
      }

      result = hil_watchdog_set_pwm_expiration_state
        (q_srv02_enc_DWork.HILInitialize_Card,
         &q_srv02_enc_P.HILInitialize_POChannels[0], 8U,
         &q_srv02_enc_DWork.HILInitialize_POValues[0]);
      if (result < 0) {
        msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
          (_rt_error_message));
        rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
        return;
      }
    }
  }

  /* Start for S-Function (hil_read_analog_timebase_block): '<Root>/HIL Read Analog Timebase' */

  /* S-Function Block: q_srv02_enc/HIL Read Analog Timebase (hil_read_analog_timebase_block) */
  {
    t_error result;
    result = hil_task_create_analog_reader(q_srv02_enc_DWork.HILInitialize_Card,
      q_srv02_enc_P.HILReadAnalogTimebase_SamplesIn,
      q_srv02_enc_P.HILReadAnalogTimebase_Channels, 2,
      &q_srv02_enc_DWork.HILReadAnalogTimebase_Task);
    if (result < 0) {
      msg_get_error_messageA(NULL, result, _rt_error_message, sizeof
        (_rt_error_message));
      rtmSetErrorStatus(q_srv02_enc_M, _rt_error_message);
    }
  }

  MdlInitialize();
}

void MdlTerminate(void)
{
  q_srv02_enc_terminate();
}

RT_MODEL_q_srv02_enc *q_srv02_enc(void)
{
  q_srv02_enc_initialize(1);
  return q_srv02_enc_M;
}

/*========================================================================*
 * End of GRT compatible call interface                                   *
 *========================================================================*/
