/*
 * q_srv02_spd_data.c
 *
 * Real-Time Workshop code generation for Simulink model "q_srv02_spd.mdl".
 *
 * Model version              : 1.223
 * Real-Time Workshop version : 7.5  (R2010a)  25-Jan-2010
 * C source code generated on : Mon Dec 05 13:47:14 2011
 *
 * Target selection: quarc_windows.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: 32-bit Generic
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "q_srv02_spd.h"
#include "q_srv02_spd_private.h"

/* Block parameters (auto storage) */
Parameters_q_srv02_spd q_srv02_spd_P = {
  0.0,                                 /* Expression: bsp
                                        * Referenced by: '<S5>/Set-Point Weight'
                                        */
  0.0,                                 /* Expression: kp
                                        * Referenced by: '<S5>/Proportional Gain  (V.s//rad)'
                                        */
  -1.6,                                /* Expression: -4*a*f
                                        * Referenced by: '<S9>/-R0*(t-1//(2*f))'
                                        */
  1.6,                                 /* Expression: 4*a*f
                                        * Referenced by: '<S9>/R0'
                                        */
  -6.1435589670200397E-001,            /* Expression: K_POT
                                        * Referenced by: '<S10>/Potentiometer Calibration  (rad//V)'
                                        */
  0.0,                                 /* Expression: set_other_outputs_at_start
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0.0,                                 /* Expression: set_other_outputs_at_switch_in
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0.0,                                 /* Expression: set_other_outputs_at_terminate
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0.0,                                 /* Expression: set_other_outputs_at_switch_out
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  10.0,                                /* Expression: analog_input_maximums
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  -10.0,                               /* Expression: analog_input_minimums
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  10.0,                                /* Expression: analog_output_maximums
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  -10.0,                               /* Expression: analog_output_minimums
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0.0,                                 /* Expression: initial_analog_outputs
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0.0,                                 /* Expression: final_analog_outputs
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0.0,                                 /* Expression: watchdog_analog_outputs
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  2.4305934065934067E+004,             /* Expression: pwm_frequency
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0.0,                                 /* Expression: pwm_leading_deadband
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0.0,                                 /* Expression: pwm_trailing_deadband
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0.0,                                 /* Expression: initial_pwm_outputs
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0.0,                                 /* Expression: final_pwm_outputs
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0.0,                                 /* Expression: watchdog_pwm_outputs
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  1.5339807878856412E-003,             /* Expression: K_ENC
                                        * Referenced by: '<S10>/Encoder Calibration  (rad//count)'
                                        */

  /*  Computed Parameter: EncoderHighPassFilter_A
   * Referenced by: '<S10>/Encoder High-Pass Filter'
   */
  { -7.1251321383416519E+002, -1.5668983947169466E+005 },

  /*  Computed Parameter: EncoderHighPassFilter_C
   * Referenced by: '<S10>/Encoder High-Pass Filter'
   */
  { 1.5668983947169466E+005, 0.0 },
  1.0,                                 /* Expression: 1
                                        * Referenced by: '<S8>/Pos Src'
                                        */
  -9.9733100113961670E-001,            /* Expression: K_TACH
                                        * Referenced by: '<S10>/Tachometer Calibration  (rad//s//V)'
                                        */
  1.0,                                 /* Expression: 1
                                        * Referenced by: '<S8>/Spd Src'
                                        */
  1.0,                                 /* Expression: sig_type
                                        * Referenced by: '<S7>/Constant'
                                        */
  1.0,                                 /* Expression: a
                                        * Referenced by: '<S7>/Square Wave'
                                        */
  0.4,                                 /* Expression: f
                                        * Referenced by: '<S7>/Square Wave'
                                        */
  2.5,                                 /* Expression: 1/f
                                        * Referenced by: '<S9>/Period (s)'
                                        */
  1.25,                                /* Expression: 1/(2*f)
                                        * Referenced by: '<S9>/Half Period (s)'
                                        */
  1.0,                                 /* Expression: a
                                        * Referenced by: '<S9>/Amplitude'
                                        */
  1.0,                                 /* Expression: a
                                        * Referenced by: '<S7>/Sine Wave'
                                        */
  0.4,                                 /* Expression: f
                                        * Referenced by: '<S7>/Sine Wave'
                                        */
  2.5,                                 /* Expression: gain
                                        * Referenced by: '<S1>/Slider Gain'
                                        */
  1.0,                                 /* Expression: 1
                                        * Referenced by: '<Root>/Constant '
                                        */
  5.0,                                 /* Expression: gain
                                        * Referenced by: '<S2>/Slider Gain'
                                        */
  0.0,                                 /* Expression: 0
                                        * Referenced by: '<S5>/Integrator'
                                        */
  0.0,                                 /* Expression: 0
                                        * Referenced by: '<S3>/Integrator'
                                        */
  -1.0,                                /* Computed Parameter: LeadCompensator_A
                                        * Referenced by: '<S3>/Lead Compensator'
                                        */
  0.0,                                 /* Computed Parameter: LeadCompensator_C
                                        * Referenced by: '<S3>/Lead Compensator'
                                        */
  1.0,                                 /* Computed Parameter: LeadCompensator_D
                                        * Referenced by: '<S3>/Lead Compensator'
                                        */
  -1.0,                                /* Expression: -1
                                        * Referenced by: '<S11>/Direction Convention: (Right-Hand) system'
                                        */
  24.0,                                /* Expression: VMAX_AMP
                                        * Referenced by: '<S11>/AMP Saturation (V)'
                                        */
  -24.0,                               /* Expression: -VMAX_AMP
                                        * Referenced by: '<S11>/AMP Saturation (V)'
                                        */
  1.0,                                 /* Expression: 1/K_AMP
                                        * Referenced by: '<S11>/Inverse Amplifier  Gain (V//V)'
                                        */
  10.0,                                /* Expression: VMAX_DAC
                                        * Referenced by: '<S11>/DACB Saturation (V)'
                                        */
  -10.0,                               /* Expression: -VMAX_DAC
                                        * Referenced by: '<S11>/DACB Saturation (V)'
                                        */
  -1.0,                                /* Expression: -K_AMP
                                        * Referenced by: '<S11>/Amplifier  Gain (V//V)'
                                        */
  0.0,                                 /* Expression: Kc
                                        * Referenced by: '<S3>/Proportional  Gain (V//rad)'
                                        */
  0.0,                                 /* Expression: ki
                                        * Referenced by: '<S5>/Integral Gain (V//rad)'
                                        */

  /*  Computed Parameter: HILInitialize_CKChannels
   * Referenced by: '<S10>/HIL Initialize'
   */
  { 0, 1, 2 },
  1,                                   /* Computed Parameter: HILInitialize_DOWatchdog
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_EIInitial
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_POModes
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_POConfiguration
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_POAlignment
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  1,                                   /* Computed Parameter: HILInitialize_POPolarity
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILReadAnalogTimebase_Clock
                                        * Referenced by: '<S10>/HIL Read Analog Timebase'
                                        */

  /*  Computed Parameter: HILInitialize_AIChannels
   * Referenced by: '<S10>/HIL Initialize'
   */
  { 0U, 1U, 2U, 3U, 4U, 5U, 6U, 7U },

  /*  Computed Parameter: HILInitialize_AOChannels
   * Referenced by: '<S10>/HIL Initialize'
   */
  { 0U, 1U, 2U, 3U, 4U, 5U, 6U, 7U },

  /*  Computed Parameter: HILInitialize_EIChannels
   * Referenced by: '<S10>/HIL Initialize'
   */
  { 0U, 1U, 2U, 3U, 4U, 5U, 6U, 7U },
  4U,                                  /* Computed Parameter: HILInitialize_EIQuadrature
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */

  /*  Computed Parameter: HILInitialize_POChannels
   * Referenced by: '<S10>/HIL Initialize'
   */
  { 0U, 1U, 2U, 3U, 4U, 5U, 6U, 7U },

  /*  Computed Parameter: HILReadAnalogTimebase_Channels
   * Referenced by: '<S10>/HIL Read Analog Timebase'
   */
  { 0U, 1U },
  500U,                                /* Computed Parameter: HILReadAnalogTimebase_SamplesIn
                                        * Referenced by: '<S10>/HIL Read Analog Timebase'
                                        */
  0U,                                  /* Computed Parameter: HILReadEncoder_Channels
                                        * Referenced by: '<S10>/HIL Read Encoder'
                                        */
  0U,                                  /* Computed Parameter: HILWriteAnalog_Channels
                                        * Referenced by: '<S10>/HIL Write Analog'
                                        */
  1U,                                  /* Expression: uint8(1)
                                        * Referenced by: '<S4>/Constant'
                                        */
  0U,                                  /* Expression: uint8(0)
                                        * Referenced by: '<S4>/SwitchControl'
                                        */
  1,                                   /* Computed Parameter: HILInitialize_Active
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_CKPStart
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_CKPEnter
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  1,                                   /* Computed Parameter: HILInitialize_AIPStart
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_AIPEnter
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  1,                                   /* Computed Parameter: HILInitialize_AOPStart
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_AOPEnter
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  1,                                   /* Computed Parameter: HILInitialize_AOStart
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_AOEnter
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  1,                                   /* Computed Parameter: HILInitialize_AOTerminate
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_AOExit
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_AOReset
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_DOPStart
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_DOPEnter
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  1,                                   /* Computed Parameter: HILInitialize_DOStart
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_DOEnter
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  1,                                   /* Computed Parameter: HILInitialize_DOTerminate
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_DOExit
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_DOReset
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  1,                                   /* Computed Parameter: HILInitialize_EIPStart
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_EIPEnter
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  1,                                   /* Computed Parameter: HILInitialize_EIStart
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_EIEnter
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  1,                                   /* Computed Parameter: HILInitialize_POPStart
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_POPEnter
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  1,                                   /* Computed Parameter: HILInitialize_POStart
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_POEnter
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  1,                                   /* Computed Parameter: HILInitialize_POTerminate
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_POExit
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_POReset
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  0,                                   /* Computed Parameter: HILInitialize_OOReset
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  1,                                   /* Computed Parameter: HILInitialize_DOInitial
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  1,                                   /* Computed Parameter: HILInitialize_DOFinal
                                        * Referenced by: '<S10>/HIL Initialize'
                                        */
  1,                                   /* Computed Parameter: HILReadAnalogTimebase_Active
                                        * Referenced by: '<S10>/HIL Read Analog Timebase'
                                        */
  1,                                   /* Computed Parameter: HILReadEncoder_Active
                                        * Referenced by: '<S10>/HIL Read Encoder'
                                        */
  0                                    /* Computed Parameter: HILWriteAnalog_Active
                                        * Referenced by: '<S10>/HIL Write Analog'
                                        */
};
